﻿package {
	
	import Box2DAS.*;
	import Box2DAS.Collision.*;
	import Box2DAS.Collision.Shapes.*;
	import Box2DAS.Common.*;
	import Box2DAS.Dynamics.*;
	import Box2DAS.Dynamics.Contacts.*;
	import Box2DAS.Dynamics.Joints.*;
	import misc.*;
	import flash.events.*;
	
	public class Impulse extends Test {
		
		public function Impulse() {
			super();
			
			Main.txt.text = "Contact Impulse:\n";
			
			b2Def.circle.m_radius = 13 / scale;
			b2Def.body.position.x = 300 / scale;
			b2Def.body.position.y = 300 / scale;
			b2Def.body.type = b2Body.b2_dynamicBody;
			var b:b2Body = b2Def.body.create(this);
			var f:b2Fixture;
			with(b2Def.fixture) {
				shape = b2Def.circle;
				density = 1.0;
				f = create(b);
				f.addEventListener(ContactEvent.PRE_SOLVE, handlePreSolve, false, 0, true);
				f.addEventListener(ContactEvent.POST_SOLVE, handlePostSolve, false, 0, true);
			}
			f.m_reportPostSolve = true;
		}
		
		public function handlePreSolve(e:ContactEvent):void {
			trace('pre: ', e.contact.m_manifold.points[0].tangentImpulse, e.contact.m_manifold.points[0].normalImpulse);
		}

		public function handlePostSolve(e:ContactEvent):void {
			Main.txt.text = "Contact Impulse:\n" + e.impulses.tangentImpulse1 + ', ' + e.impulses.normalImpulse1;
			trace('post: ', e.impulses.tangentImpulse1, e.impulses.normalImpulse1);
			trace('post: ', e.contact.m_manifold.points[0].tangentImpulse, e.contact.m_manifold.points[0].normalImpulse);			
		}
	}
}