﻿package {
	
	import Box2DAS.*;
	import Box2DAS.Collision.*;
	import Box2DAS.Collision.Shapes.*;
	import Box2DAS.Common.*;
	import Box2DAS.Dynamics.*;
	import Box2DAS.Dynamics.Contacts.*;
	import Box2DAS.Dynamics.Joints.*;
	import misc.*;
	
	public class Ragdoll extends Test {
		
		public function Ragdoll() {
			super();
			
			Main.txt.text = "Ragdoll";
			
			for (var i:int = 0; i < 2; i++){
				var startX:Number = 70 + Math.random() * 20 + 480 * i;
				var startY:Number = 20 + Math.random() * 50;
				
				// BODIES
				
				// Head
				b2Def.circle.m_radius = 12.5 / scale;
				b2Def.fixture.shape = b2Def.circle;
				b2Def.fixture.density = 1.0;
				b2Def.fixture.friction = 0.4;
				b2Def.fixture.restitution = 0.3;
				b2Def.body.type = b2Body.b2_dynamicBody;
				b2Def.body.position.v2 = new V2(startX / scale, startY / scale);
				
				var head:b2Body = CreateBody(b2Def.body);
				head.CreateFixture(b2Def.fixture);
				//if (i == 0){
					head.ApplyImpulse(new V2(Math.random() * 100 - 50, Math.random() * 100 - 50), head.GetWorldCenter());
				//}
				
				//Torso
				var torso:Array = new Array;
				for (var t:int = 0; t < 3; ++t)
				{
					b2Def.polygon.SetAsBox(15 / scale, 10 / scale);
					b2Def.fixture.shape = b2Def.polygon;
					b2Def.fixture.density = 1.0;
					b2Def.fixture.friction = 0.4;
					b2Def.fixture.restitution = 0.1;
					b2Def.body.position.v2 = new V2(startX / scale, (startY + 28 + t * 15) / scale);
					var torsoB:b2Body = CreateBody(b2Def.body);
					torsoB.CreateFixture(b2Def.fixture);
					torso.push(torsoB);
				}
				
				// UpperArm
				b2Def.fixture.density = 1.0;
				b2Def.fixture.friction = 0.4;
				b2Def.fixture.restitution = 0.1;
				// L
				b2Def.polygon = new b2PolygonShape();
				b2Def.polygon.SetAsBox(18 / scale, 6.5 / scale);
				b2Def.fixture.shape = b2Def.polygon;
				b2Def.body.position.v2 = new V2((startX - 30) / scale, (startY + 20) / scale);
				var upperArmL:b2Body = CreateBody(b2Def.body);
				upperArmL.CreateFixture(b2Def.fixture);
				// R
				b2Def.polygon.SetAsBox(18 / scale, 6.5 / scale);
				b2Def.fixture.shape = b2Def.polygon;
				b2Def.body.position.v2 = new V2((startX + 30) / scale, (startY + 20) / scale);
				var upperArmR:b2Body = CreateBody(b2Def.body);
				upperArmR.CreateFixture(b2Def.fixture);
				
				// LowerArm
				b2Def.fixture.density = 1.0;
				b2Def.fixture.friction = 0.4;
				b2Def.fixture.restitution = 0.1;
				// L
				b2Def.polygon.SetAsBox(17 / scale, 6 / scale);
				b2Def.fixture.shape = b2Def.polygon;
				b2Def.body.position.v2 = new V2((startX - 57) / scale, (startY + 20) / scale);
				var lowerArmL:b2Body = CreateBody(b2Def.body);
				lowerArmL.CreateFixture(b2Def.fixture);
				// R
				b2Def.polygon.SetAsBox(17 / scale, 6 / scale);
				b2Def.fixture.shape = b2Def.polygon;
				b2Def.body.position.v2 = new V2((startX + 57) / scale, (startY + 20) / scale);
				var lowerArmR:b2Body = CreateBody(b2Def.body);
				lowerArmR.CreateFixture(b2Def.fixture);
				//
				// UpperLeg
				b2Def.fixture.density = 1.0;
				b2Def.fixture.friction = 0.4;
				b2Def.fixture.restitution = 0.1;
				// L
				b2Def.polygon.SetAsBox(7.5 / scale, 22 / scale);
				b2Def.fixture.shape = b2Def.polygon;
				b2Def.body.position.v2 = new V2((startX - 8) / scale, (startY + 85) / scale);
				var upperLegL:b2Body = CreateBody(b2Def.body);
				upperLegL.CreateFixture(b2Def.fixture);
				// R
				b2Def.polygon.SetAsBox(7.5 / scale, 22 / scale);
				b2Def.fixture.shape = b2Def.polygon;
				b2Def.body.position.v2 = new V2((startX + 8) / scale, (startY + 85) / scale);
				var upperLegR:b2Body = CreateBody(b2Def.body);
				upperLegR.CreateFixture(b2Def.fixture);
				//
				// LowerLeg
				b2Def.fixture.density = 1.0;
				b2Def.fixture.friction = 0.4;
				b2Def.fixture.restitution = 0.1;
				// L
				b2Def.polygon.SetAsBox(6 / scale, 20 / scale);
				b2Def.fixture.shape = b2Def.polygon;
				b2Def.body.position.v2 = new V2((startX - 8) / scale, (startY + 120) / scale);
				var lowerLegL:b2Body = CreateBody(b2Def.body);
				lowerLegL.CreateFixture(b2Def.fixture);
				// R
				b2Def.polygon.SetAsBox(6 / scale, 20 / scale);
				b2Def.fixture.shape = b2Def.polygon;
				b2Def.body.position.v2 = new V2((startX + 8) / scale, (startY + 120) / scale);
				var lowerLegR:b2Body = CreateBody(b2Def.body);
				lowerLegR.CreateFixture(b2Def.fixture);

				// JOINTS
				b2Def.revoluteJoint.enableLimit = true;
				
				// Head to shoulders
				b2Def.revoluteJoint.lowerAngle = -40 / (180 / Math.PI);
				b2Def.revoluteJoint.upperAngle = 40 / (180 / Math.PI);
				b2Def.revoluteJoint.Initialize(torso[0], head, new V2(startX / scale, (startY + 15) / scale));
				CreateJoint(b2Def.revoluteJoint);
				
				// Upper arm to shoulders
				// L
				b2Def.revoluteJoint.lowerAngle = -85 / (180/Math.PI);
				b2Def.revoluteJoint.upperAngle = 130 / (180/Math.PI);
				b2Def.revoluteJoint.Initialize(torso[0], upperArmL, new V2((startX - 18) / scale, (startY + 20) / scale));
				CreateJoint(b2Def.revoluteJoint);
				// R
				b2Def.revoluteJoint.lowerAngle = -130 / (180/Math.PI);
				b2Def.revoluteJoint.upperAngle = 85 / (180/Math.PI);
				b2Def.revoluteJoint.Initialize(torso[0], upperArmR, new V2((startX + 18) / scale, (startY + 20) / scale));
				CreateJoint(b2Def.revoluteJoint);
				//
				// Lower arm to upper arm
				// L
				b2Def.revoluteJoint.lowerAngle = -130 / (180/Math.PI);
				b2Def.revoluteJoint.upperAngle = 10 / (180/Math.PI);
				b2Def.revoluteJoint.Initialize(upperArmL, lowerArmL, new V2((startX - 45) / scale, (startY + 20) / scale));
				CreateJoint(b2Def.revoluteJoint);
				// R
				b2Def.revoluteJoint.lowerAngle = -10 / (180/Math.PI);
				b2Def.revoluteJoint.upperAngle = 130 / (180/Math.PI);
				b2Def.revoluteJoint.Initialize(upperArmR, lowerArmR, new V2((startX + 45) / scale, (startY + 20) / scale));
				CreateJoint(b2Def.revoluteJoint);
				
				// Shoulders/stomach
				b2Def.revoluteJoint.lowerAngle = -15 / (180 / Math.PI);
				b2Def.revoluteJoint.upperAngle = 15 / (180 / Math.PI);
				b2Def.revoluteJoint.Initialize(torso[0], torso[1], new V2(startX / scale, (startY + 35) / scale));
				CreateJoint(b2Def.revoluteJoint);
				// Stomach/hips
				b2Def.revoluteJoint.Initialize(torso[1], torso[2], new V2(startX / scale, (startY + 50) / scale));
				CreateJoint(b2Def.revoluteJoint);
				
				// Torso to upper leg
				// L
				b2Def.revoluteJoint.lowerAngle = -25 / (180/Math.PI);
				b2Def.revoluteJoint.upperAngle = 45 / (180/Math.PI);
				b2Def.revoluteJoint.Initialize(torso[2], upperLegL, new V2((startX - 8) / scale, (startY + 72) / scale));
				CreateJoint(b2Def.revoluteJoint);
				// R
				b2Def.revoluteJoint.lowerAngle = -45 / (180/Math.PI);
				b2Def.revoluteJoint.upperAngle = 25 / (180/Math.PI);
				b2Def.revoluteJoint.Initialize(torso[2], upperLegR, new V2((startX + 8) / scale, (startY + 72) / scale));
				CreateJoint(b2Def.revoluteJoint);

				// Upper leg to lower leg
				// L
				b2Def.revoluteJoint.lowerAngle = -25 / (180/Math.PI);
				b2Def.revoluteJoint.upperAngle = 115 / (180/Math.PI);
				b2Def.revoluteJoint.Initialize(upperLegL, lowerLegL, new V2((startX - 8) / scale, (startY + 105) / scale));
				CreateJoint(b2Def.revoluteJoint);
				// R
				b2Def.revoluteJoint.lowerAngle = -115 / (180/Math.PI);
				b2Def.revoluteJoint.upperAngle = 25 / (180/Math.PI);
				b2Def.revoluteJoint.Initialize(upperLegR, lowerLegR, new V2((startX + 8) / scale, (startY + 105) / scale));
				CreateJoint(b2Def.revoluteJoint);
			}

			// Add stairs on the left
			b2Def.fixture.friction = 0.4;
			b2Def.fixture.restitution = 0.3;
			b2Def.body.type = b2Body.b2_staticBody;
			for (var j:int = 1; j <= 12; j++) {
				b2Def.polygon.SetAsBox((10*j) / scale, 10 / scale);
				b2Def.fixture.shape = b2Def.polygon;
				b2Def.body.position.v2 = new V2((10*j) / scale, (230 + 20*j) / scale);
				head = CreateBody(b2Def.body);
				head.CreateFixture(b2Def.fixture);
			}

			// Add stairs on the right
			for (var k:int = 1; k <= 12; k++){
				b2Def.polygon.SetAsBox((10 * k) / scale, 10 / scale);
				b2Def.fixture.shape = b2Def.polygon;
				b2Def.body.position.v2 = new V2((720-10*k) / scale, (230 + 20*k) / scale);
				head = CreateBody(b2Def.body);
				head.CreateFixture(b2Def.fixture);
			}

			b2Def.polygon.SetAsBox(30 / scale, 40 / scale);
			b2Def.fixture.shape = b2Def.polygon;
			b2Def.body.position.v2 = new V2(360 / scale, 320 / scale);
			head = CreateBody(b2Def.body);
			head.CreateFixture(b2Def.fixture);
		}
	}
}